function main()
    all_methods = Method[]
    for base_prop_sym in propertynames(Base)
        base_prop = getproperty(Base, base_prop_sym)
        if !(base_prop isa Function)
            continue
        end
        if !Base.isexported(Base, base_prop_sym) && !Base.ispublic(Base, base_prop_sym)
            continue
        end

        push!(all_methods, methods(base_prop)...)
    end
    num_methods = length(all_methods)
    @info "number of methods: $(num_methods)"
    dists = zeros((num_methods, num_methods))
    @showprogress Threads.@threads for (i, j) in Choose(2, num_methods) |> collect
        dists[i, j] = distance(all_methods[i], all_methods[j])
    end
    dists
end
