struct MethodInfo
    "type vars (maybe `TypeVar`s?)"
    tv::Vector{Any}
    "signature"
    sig::Type
    "argument names, including the function itself"
    args::Vector{Symbol}
    "keyword arguments"
    kwargs::Vector{Symbol}
    "definition location"
    file::String
    "definition location"
    line::Int64
end

function get_method_info(m::Method)
    tv = Any[]
    sig = m.sig
    while isa(sig, UnionAll)
        push!(tv, sig.var)
        sig = sig.body
    end
    file, line = Base.updated_methodloc(m)
    argnames = Base.method_argnames(m)
    if length(argnames) >= m.nargs
        show_env = Base.ImmutableDict{Symbol,Any}()
        for t in tv
            show_env = Base.ImmutableDict(show_env, :unionall_env => t)
        end
        decls = Tuple{String,String}[Base.argtype_decl(show_env, argnames[i], sig, i, m.nargs, m.isva)
                                     for i = 1:m.nargs]
        # decls[1] = ("", sprint(Base.show_signature_function, Base.unwrapva(sig.parameters[1]), false, decls[1][1], html,
        #                        context = show_env))
    else
        # decls = Tuple{String,String}[("", "") for i = 1:length(sig.parameters::SimpleVector)]
    end
    # return tv, decls, file, line
    return MethodInfo(tv, sig, argnames, Base.kwarg_decl(m), file, line)
end

