struct Choose{M,N}
	function Choose(m::Integer, n::Integer)
		if m > n
			m, n = n, m
		end
		new{m,n}()
	end
end

function Base.iterate(::Choose{M,N}) where {M,N}
    if M == 0
        return nothing
    end
	ret = ntuple(identity, M)
	ret, ret
end

function Base.iterate(::Choose{M,N}, state) where {M,N}
	if state[1] == N - M + 1
		return nothing
	end
	for (i, v) in Iterators.reverse(enumerate(state))
		if v != N - M + i
			ret = ntuple(M) do j
				if j < i
					state[j]
				else
					v + (j - i) + 1
				end
			end
			return ret, ret
		end
	end
	error("must not reachable")
end

Base.haslength(::Choose{M,N}) where {M,N} = Base.HasLength()

function Base.length(::Choose{M,N}) where {M,N}
	binomial(N, M)
end

function Base.eltype(::Choose{M,N}) where {M,N}
	NTuple{M, Int64}
end

